//
// This file is part of the GNU ARM Eclipse distribution.
// Copyright (c) 2014 Liviu Ionescu.
//

#ifndef STEPMOTOR_H_
#define STEPMOTOR_H_

#include "stm32f30x.h"

// ----- LED definitions ------------------------------------------------------

// Adjust these definitions for your own board.

// STM32F3DISCOVERY definitions (GREEN led, E15, active high)
// (SEGGER J-Link device name: STM32F303VC).

// Port numbers: 0=A, 1=B, 2=C, 3=D, 4=E, 5=F, 6=G, ...
#define STEP_PORT_NUMBER               (3)
#define STEP_PIN_NUMBER_MIN            (12)
#define STEP_PIN_ALL_MASK              (0x0F << STEP_PIN_NUMBER_MIN)

#define STEP_GPIOx(_N)                 ((GPIO_TypeDef *)(GPIOA_BASE + (GPIOB_BASE-GPIOA_BASE)*(_N)))
#define STEP_PIN_MASK(_N)              (1 << (_N))
#define STEP_RCC_MASKx(_N)             (RCC_AHBPeriph_GPIOA << (_N))
// ----------------------------------------------------------------------------

typedef struct {
	int step;
} StepMotorState;


void step_init(StepMotorState *state);
void step_forward(StepMotorState *state);
void step_backward(StepMotorState *state);
void step_stop(StepMotorState *state);




#endif
